# Contributing to HypoFuzz

HypoFuzz aims to be a production-ready tool, but it's also a reasearch project
spun out of my (Zac Hatfield-Dodds) PhD.  Contributions are welcome but likely to
be challenging if you're not already familiar with [Hypothesis](https://github.com/HypothesisWorks/hypothesis).
If you're looking to get started in the ecosystem, I recommend starting there.


## Contributor License Agreement

HypoFuzz is distributed under a custom license, which permits non-commercial use for free but
requires commercial users to hold a separate written commercial license agreement.
(Contact sales@hypofuzz.com or visit hypofuzz.com/pricing if you need one of those)
We therefore require all contributors to agree to the CLA, and add their name to the authors list below.

<details>
  <summary>Full text of the Contributor License Agreement</summary>

In the following Agreement, "the HypoFuzz maintainers" means Zac Hatfield-Dodds, or such individuals and/or organizations as may be designated by Zac from time to time.

You accept and agree to the following terms and conditions for Your present and future Contributions submitted to this repository. Except for the license granted herein to the HypoFuzz maintainers and recipients of software distributed by the HypoFuzz maintainers, You reserve all right, title, and interest in and to Your Contributions.

1. Definitions.

"You" (or "Your") shall mean the copyright owner or legal entity authorized by the copyright owner that is making this Agreement with the HypoFuzz maintainers. For legal entities, the entity making a Contribution and all other entities that control, are controlled by, or are under common control with that entity are considered to be a single Contributor. For the purposes of this definition, "control" means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity.

"Contribution" shall mean any original work of authorship, including any modifications or additions to an existing work, that is intentionally submitted by You to the HypoFuzz maintainers for inclusion in, or documentation of, any of the products owned or managed by the HypoFuzz maintainers (the "Work"). For the purposes of this definition, "submitted" means any form of electronic, verbal, or written communication sent to the HypoFuzz maintainers, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the HypoFuzz maintainers for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by You as "Not a Contribution."

2. Grant of Copyright License. Subject to the terms and conditions of this Agreement, You hereby grant to the HypoFuzz maintainers and to recipients of software distributed by the HypoFuzz maintainers a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare derivative works of, publicly display, publicly perform, sublicense, and distribute Your Contributions and such derivative works.

3. Grant of Patent License. Subject to the terms and conditions of this Agreement, You hereby grant to the HypoFuzz maintainers and to recipients of software distributed by the HypoFuzz maintainers a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by You that are necessarily infringed by Your Contribution(s) alone or by combination of Your Contribution(s) with the Work to which such Contribution(s) was submitted. If any entity institutes patent litigation against You or any other entity (including a cross-claim or counterclaim in a lawsuit) alleging that your Contribution, or the Work to which you have contributed, constitutes direct or contributory patent infringement, then any patent licenses granted to that entity under this Agreement for that Contribution or Work shall terminate as of the date such litigation is filed.

4. You represent that you are legally entitled to grant the above license. If your employer(s) has rights to intellectual property that you create that includes your Contributions, you represent that you have received permission to make Contributions on behalf of that employer, that your employer has waived such rights for your Contributions to the HypoFuzz maintainers, or that your employer has executed a separate Corporate CLA with the HypoFuzz maintainers.

5. You represent that each of Your Contributions is Your original creation (see section 7 for submissions on behalf of others). You represent that Your Contribution submissions include complete details of any third-party license or other restriction (including, but not limited to, related patents and trademarks) of which you are personally aware and which are associated with any part of Your Contributions.

6. You are not expected to provide support for Your Contributions, except to the extent You desire to provide support. You may provide support for free, for a fee, or not at all. Unless required by applicable law or agreed to in writing, You provide Your Contributions on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON- INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE.

7. Should You wish to submit work that is not Your original creation, You may submit it to the HypoFuzz maintainers separately from any Contribution, identifying the complete details of its source and of any license or other restriction (including, but not limited to, related patents, trademarks, and license agreements) of which you are personally aware, and conspicuously marking the work as "Submitted on behalf of a third-party: [named here]".

8. You agree to notify the HypoFuzz maintainers of any facts or circumstances of which you become aware that would make these representations inaccurate in any respect.

</details>


## Authors

**[Zac Hatfield-Dodds](https://zhd.dev/)** is the project founder and main author of HypoFuzz.

**Other contributors:**
<!-- Add yourself to the end of the bulleted list below -->

* [Liam DeVoe](https://github.com/tybug)
